#include <3048F.H>

void wait_val(unsigned char out_data[3]);

unsigned char read_RC(void);
void print_i(int data);
void print(char disp_data[16]);
void LCD_init(void);
void LCD_out8(char data, char RS);
void LCD_out4(char data, char RS);
void wait_4m(void);
void wait(unsigned char count);
void wait_1m(void);

/*************************************************************/
/**  21 m sec̊ԑ҂                                       **/
/*************************************************************/
void wait_21m(void)
{
unsigned char c, fl;

	fl = 1;
	while(fl == 1)
	{
		c = ITU0.TSR.BYTE & 0x01;
		if(c == 1)
		{
			c = ITU0.TSR.BYTE;
			ITU0.TSR.BYTE = c & 0xfe;
			fl = 0;
		}
	}
	return;
}
/*************************************************************/
/**  2.3m sec̊ԑ҂(1ch̎)                          **/
/*************************************************************/
void wait_2m(void)
{
unsigned char c, fl;

/*P4.DR.BYTE = 3;*/

	fl = 1;
	while(fl == 1)
	{
		c = ITU2.TSR.BYTE & 0x01;
		if(c == 1)
		{
			c = ITU2.TSR.BYTE;
			ITU2.TSR.BYTE = c & 0xfe;
			fl = 0;
		}
	}
	return;
}
/*********************************************************************/
/*********************************************************************/
unsigned char read_RC(void)
{
unsigned char	read_data;

	read_data = (unsigned char)((P4.DR.BYTE & 0xf0) / 16);
	return(read_data);
}
/*********************************************************************/
/**  O`QTT܂ł̐i߂Ńvg                 **/
/*********************************************************************/
void print_i(int data)
{
int				org_data;
unsigned char	j;
char			string[16];

	org_data = data;

	/* Clear screen */
	LCD_out4(0x01, 0);
	wait_4m();

	/*100̈*/
	j = (unsigned char)(data / 100);
	if(j != 0) string[0] = 0x30 + j;
	else	   string[0] = 0x20;
	
	/*10̈*/
	data = data - (int)j * 100;
	j = (unsigned char)(data / 10);
	if(j != 0) string[1] = 0x30 + j;
	if(j == 0 && org_data >= 100)string[1] = 0x30;
	if(j == 0 && org_data < 100) string[1] = 0x20;
	
	/*1̈*/
	data = data - (int)j * 10;
	j = (unsigned char)data;	
	string[2] = 0x30 + j;

	string[3] = 0;

	print(string);
	return;
}
/*********************************************************************/
void print(char disp_data[16])
{
char	i, j;

	/*̏INA*/
	for(i = 0; i < 16; i++)
	{
		if(disp_data[i] == 0)
		{
			for(j = i; j < 16; j++)
			{
				disp_data[j] = 0x20;
			}
			break;
		}
	}

	/* Clear screen */
	/*
	LCD_out4(0x01, 0);
	wait_4m();
	*/

	for(i = 0; i < 16; i++)
	{
		LCD_out4(disp_data[i], 1);
		wait_4m();
	}

	return;
}
/*********************************************************************/
void LCD_init(void)
{
unsigned char c, RS;

	/* LCD̏*/
	wait_4m();
	wait_4m();
	wait_4m();
	wait_4m();

	RS = 0;/*command mode*/
	/*LCD t@NVZbgP*/
	c = 0x03;
	LCD_out8(c, RS);

	/*LCD t@NVZbg2*/
	c = 0x03;
	LCD_out8(c, RS);

	/*LCD t@NVZbg3*/
	c = 0x03;
	LCD_out8(c, RS);

	/*LCD t@NVZbg*/
	c = 0x02;
	LCD_out8(c, RS);

	/*ݒ********************************************/
	c = 0x28;
	LCD_out4(c, RS);

	c = 0x08;
	LCD_out4(c, RS);/*\It*/

	c = 0x01;
	LCD_out4(c, RS);/*\I*/

	c = 0x06;
	LCD_out4(c, RS);/*Gg[[h*/

	c = 0x0f;
	LCD_out4(c, RS);/*ON*/

	c = 0x01;
	LCD_out4(c, RS);/*\NA*/

	c = 0x02;
	LCD_out4(c, RS);/*J[\z[*/

}
/*********************************************************************/
void LCD_out8(char data, char RS)
{
char i, j;

	if(RS > 0) P3.DR.BIT.B4 = 1;/*RSMZbg*/
	else  P3.DR.BIT.B4 = 0;

	i = P3.DR.BYTE & 0xf0;
	j = data & 0x0f;
	i = i | j;
	P3.DR.BYTE = data;/*R}h@/@f[^o*/
	
	P3.DR.BIT.B5 = 1;/*EMZbg*/
	wait_4m();
	P3.DR.BIT.B5 = 0;/*EMZbg*/
	wait_4m();
	
}
/*********************************************************************/
/*^ꂽWbit̃f[^ʁ|ʏ4bit2ɕď*/
void LCD_out4(char data, char RS)
{
char i, j;

	if(RS > 0) P3.DR.BIT.B4 = 1;/*RSMZbg*/
	else  P3.DR.BIT.B4 = 0;

	/**ʃf[^o******/

	i = P3.DR.BYTE & 0xf0;
	j = (data / 16) & 0x0f;
	i = i | j;
	P3.DR.BYTE = i;/*R}ho*/

	P3.DR.BIT.B5 = 1;/*EMZbg*/
	wait_4m();
	P3.DR.BIT.B5 = 0;/*EMZbg*/
	wait_4m();

	/**ʃf[^o****************************************/
	i = P3.DR.BYTE & 0xf0;
	j = data & 0x0f;
	i = i | j;
	P3.DR.BYTE = i;/*R}ho*/

	P3.DR.BIT.B5 = 1;/*EMZbg*/
	wait_4m();
	P3.DR.BIT.B5 = 0;/*EMZbg*/
	wait_4m();
}
/*************************************************************/
/**  4m sec̊ԑ҂                          **/
/*************************************************************/
void wait_4m(void)
{
unsigned char i, c, fl;

	ITU.TSTR.BIT.STR3 = 0;
	for(i = 0; i < 2; i++)
	{
		ITU.TSTR.BIT.STR3 = 1;
		fl = 1;
		while(fl == 1)
		{
			c = ITU3.TSR.BYTE & 0x01;
			if(c == 1)
			{
				c = ITU3.TSR.BYTE;
				ITU3.TSR.BYTE = c & 0xfe;
				fl = 0;
			}
		}
		ITU.TSTR.BIT.STR3 = 0;
	}
	return;
}
/*************************************************************/
/**  ҂ count = 250 ŖPb@@                          **/
/*************************************************************/
void wait(unsigned char count)
{
unsigned char i;

	for(i = 0; i < count; i++)
	{
		wait_4m();
	}
	return;
}
/*************************************************************/
/**  0.6m sec̊ԑ҂                                       **/
/*************************************************************/
void wait_1m(void)
{
unsigned char c, fl;

	ITU.TSTR.BIT.STR1 = 1;
	fl = 1;
	while(fl == 1)
	{
		c = ITU1.TSR.BYTE & 0x01;
		if(c == 1)
		{
			c = ITU1.TSR.BYTE;
			ITU1.TSR.BYTE = c & 0xfe;
			fl = 0;
		}
	}
	ITU.TSTR.BIT.STR1 = 0;
	return;
}
